-- Turbine Imports..
import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

-- Plugin Imports..
import "GaluhadPlugins.Aiskald.VindarPatch";
import "GaluhadPlugins.Aiskald.GeneralFunctions";
import "GaluhadPlugins.Aiskald.Strings";
import "GaluhadPlugins.Aiskald.Globals";
import "GaluhadPlugins.Aiskald.Images";
import "GaluhadPlugins.Aiskald.Onscreen";
import "GaluhadPlugins.Aiskald.DropDown";
import "GaluhadPlugins.Aiskald.MountFunctions";


-- Windows --
import "GaluhadPlugins.Aiskald.MainWin";
import "GaluhadPlugins.Aiskald.HUD";

-- Other imports --
import "GaluhadPlugins.Aiskald.Commands";
import "GaluhadPlugins.Aiskald.ColorPicker";



-----------------------------------------------------------------------------------------------------------

function saveData()

	-- Store the settings table.
	PatchDataSave(Turbine.DataScope.Account, "Aiskald_Settings", SETTINGS);

end


function loadData()

	---------------------------------------------------------------------------------------------------------------------------------

	-- SAVED SETTINGS --

	local SavedSettings = {};

	-- Load the settings
	function GetSavedSettings()
		SavedSettings = PatchDataLoad(Turbine.DataScope.Account, "Aiskald_Settings");
	end

	if pcall(GetSavedSettings) then
		-- Loaded without error
		SavedSettings = PatchDataLoad(Turbine.DataScope.Account, "Aiskald_Settings");
	else
		-- Loaded with errors
		SavedSettings = nil;
		Turbine.Shell.WriteLine(_LANG.SETTINGSLOADERROR[SETTINGS.LANGUAGE]);
	end


	-- Check the saved settings to make sure it is still compatible with newer updates, add in any missing default settings
	if type(SavedSettings) == 'table' then

		local tempSETTINGS = {};
		tempSETTINGS = deepcopy(DEFAULT_SETTINGS);

		SETTINGS = mergeTables(tempSETTINGS,SavedSettings);

	else

		SETTINGS = deepcopy(DEFAULT_SETTINGS);

	end

	----------------------------------------------------------------------------------------------------------------------------------

end


function DrawWindows()

	DrawMainWin();
	DrawColorPicker();

end


Turbine.Plugin.Unload = function (sender, args)
	-- Save the data when the plugin unloads.
	saveData();
end



-- Initiate load sequence
Debug("Aiskald Mount HUD v" .. Plugins["Aiskald Mount HUD"]:GetVersion() .. " by Galuhad");
loadData();
DrawWindows();
RegisterCommands();

MountedChanged();


